package by.zerg.layouteditor.theme;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.zip.GZIPInputStream;
import java.util.zip.GZIPOutputStream;

public class Config {
	private StringBuilder data;
	private final String gx;

	public Config(String gx) {
		this.gx = gx;
		data = new StringBuilder();
	}

	private int execute(String cmd) {
		int exitValue = 1;
		try {
			Process p = Runtime.getRuntime().exec(cmd);
			BufferedReader processOutput = new BufferedReader(
					new InputStreamReader(p.getInputStream()));
			BufferedReader processError = new BufferedReader(
					new InputStreamReader(p.getErrorStream()));
			while (processOutput.readLine() != null
					|| processError.readLine() != null) {
			}
			processOutput.close();
			processError.close();
			exitValue = p.waitFor();
		} catch (Throwable t) {
			t.printStackTrace();
		}
		System.out.println("exitValue: " + exitValue);
		return exitValue;
	}

	public int save() throws IOException {
		String gzip = gx.replace(".ini", ".gz");

		GZIPOutputStream gzipOutputStream = new GZIPOutputStream(
				new FileOutputStream(gzip));
		gzipOutputStream.write(getData().getBytes());
		gzipOutputStream.flush();
		gzipOutputStream.close();

		int result = execute("bin\\Crypter.exe " + gzip + " " + gx);
		new File(gzip).delete();
		return result;
	}

	public int open() throws IOException {
		data = new StringBuilder();
		String gzip = gx.replace(".ini", ".gz");
		int result = execute("bin\\Decrypter.exe " + gx + " " + gzip);
		GZIPInputStream gzipInputStream = new GZIPInputStream(
				new FileInputStream(gzip));

		byte[] buff = new byte[1024];
		int len;
		while ((len = gzipInputStream.read(buff)) > 0) {
			data.append(new String(buff, 0, len));
		}

		gzipInputStream.close();
		new File(gzip).delete();
		return result;
	}

	public String getData() {
		return data.toString();
	}

	public void setData(String data) {
		this.data = new StringBuilder(data);
	}

	public String getGx() {
		return gx;
	}
}
