package by.zerg.layouteditor.theme;

import java.io.File;

public class Theme {
	private final String id;
	private final String name;
	private final String copyright;
	private final String baseId;
	private final String folder;
	private final String deck;
	private final String feature;
	private final String lobby;
	private final String preview;

	public Theme(String id, String name, String copyright, String baseId,
			String folder, String deck, String feature, String lobby,
			String preview) {
		this.id = id;
		this.name = name;
		this.copyright = copyright;
		this.baseId = baseId == null ? id.equals("default@pokerstars.com") ? null
				: "default@pokerstars.com"
				: baseId;
		this.folder = folder;
		this.deck = deck;
		this.feature = feature;
		this.lobby = lobby;
		this.preview = preview;
	}

	@Override
	public String toString() {
		return id;
	}

	public static Theme valueOf(String id) {
		for (Theme theme : Loader.getDefaultThemes()) {
			if (theme.getId().equals(id)) {
				return theme;
			}
		}
		for (Theme theme : Loader.getCustomThemes()) {
			if (theme.getId().equals(id)) {
				return theme;
			}
		}
		return null;
	}

	public Config getConfig() {
		String gx = folder + "\\gx.ini";
		return new File(gx).exists() ? new Config(gx) : Theme.valueOf(baseId)
				.getConfig();
	}

	public String getId() {
		return id;
	}

	public String getName() {
		return name;
	}

	public String getCopyright() {
		return copyright;
	}

	public String getBaseId() {
		return baseId;
	}

	public String getFolder() {
		return folder;
	}

	public String getDeck() {
		return deck;
	}

	public String getFeature() {
		return feature;
	}

	public String getLobby() {
		return lobby;
	}

	public String getPreview() {
		return preview;
	}
}
